#include <bits/stdc++.h>

using namespace std;

int main() {
    
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cerr.tie(0);
    
    int n,o,a,b,ab;
    cin>>n;
    string grupa[n];
    int fali[n];
    cin>>o>>a>>b>>ab;
    int treba=0;
    bool moze=true;
            int mat[n][4]={0};

    
    for(int i=0;i<n;i++)
        {
            cin>>grupa[i]>>fali[i];
            treba+=fali[i];
        }
    if(treba>o+a+b+ab)
    {
        moze=false;
    }
    else
    {

        for(int i=0;i<n;i++)
        {
            if(grupa[i]=="o")
                {
                    if(o>=fali[i])
                        {
                            o-=fali[i];
                            mat[i][0]+=fali[i];
                            fali[i]=0;
                        }
                    else
                        moze=false;
                }
            else
            {
                if(grupa[i]=="A")
                {
                    if(a>=fali[i])
                    {
                        a-=fali[i];
                        mat[i][1]+=fali[i];
                        fali[i]=0;
                    }
                    else
                    {
                        if(a>0)
                        {
                           
                            mat[i][1]+=a;
                             a=0;
                            fali[i]-=a;
                        }
                    }
                }
                else
                {
                    if(grupa[i]=="B")
                    {
                        if(b>=fali[i])
                    {
                        b-=fali[i];
                        mat[i][2]+=fali[i];
                        fali[i]=0;
                    }
                    else
                    {
                        if(b>0)
                        {
                           
                            mat[i][2]+=b;
                             b=0;
                            fali[i]-=b;
                        }
                    }
                    }
                }
            }
        }
        for(int i=0;i<n;i++)
        {
            if(fali[i]>0)
            {
                if(grupa[i]=="A")
                {
                    if(o>fali[i])
                    {
                        o-=fali[i];
                        mat[i][0]+=fali[i];
                        fali[i]=0;
                    }
                    else
                        moze=false;
                }else
                if(grupa[i]=="B")
                {
                    if(o>fali[i])
                    {
                        o-=fali[i];
                        mat[i][0]+=fali[i];
                        fali[i]=0;
                    }
                    else
                        moze=false;
                }
            }
        }
        int ostalo=o+a+b+ab;
        for(int i=0;i<n;i++)
        {
            if(grupa[i]=="AB")
            {
                if(ostalo>fali[i])
                {
                    if(o>0)
                    {
                        if(fali[i]<o)
                        {
                            mat[i][0]+=fali[i];
                            o-=fali[i];
                            fali[i]=0;
                        }else
                        {
                            mat[i][0]+=o;
                            fali[i]-=o;
                            o=0;
                        }
                    }
                     if(a>0)
                    {
                        if(fali[i]<a)
                        {
                            mat[i][1]+=fali[i];
                            a-=fali[i];
                            fali[i]=0;
                        }else
                        {
                            mat[i][1]+=a;
                            fali[i]-=a;
                            a=0;
                        }
                    }
                     if(b>0)
                    {
                        if(fali[i]<b)
                        {
                            mat[i][2]+=fali[i];
                            b-=fali[i];
                            fali[i]=0;
                        }else
                        {
                            mat[i][2]+=b;
                            fali[i]-=b;
                            b=0;
                        }
                    }
                     if(ab>0)
                    {
                        if(fali[i]<ab)
                        {
                            mat[i][3]+=fali[i];
                            ab-=fali[i];
                            fali[i]=0;
                        }else
                        {
                            mat[i][3]+=ab;
                            fali[i]-=ab;
                            ab=0;
                        }
                    }
                }
                else
                    moze=false;
            }
            else
            if(fali[i]>0)
                moze=false;
        }
    }
    if(moze)
    {
        cout<<"moguce"<<endl;
        for(int i=0;i<n;i++)
            cout<<mat[i][0]<<" "<<mat[i][1]<<" "<<mat[i][2]<<" "<<mat[i][3]<<endl;
    }
    else
    {
        cout<<"nemoguce"<<endl;
    }
    
    return 0;
}